#if C_GRAPHICSMEDIA_LAB_DMOROZ_C
#/*******************************************************************************
# * (C) Copyright 2003/2004 by Vladimir Vezhnevets <vvp@graphics.cs.msu.su>     *
# *******************************************************************************/
#endif

//---------------------------------------------------------------------------

#include "Processing.h"
#include "SimpleBitmap.h"

//---------------------------------------------------------------------------
//       -      

void BoxFilter(DSimpleBitmap *in_pImage, DSimpleBitmap *out_pImage)
{
  //    
  for (int iY = 0; iY < in_pImage->GetHeight(); iY ++)
  {
    unsigned char *pcSrcLine, *pcDstLine;

    //     -    
    pcSrcLine = (unsigned char *)in_pImage->GetLinePointer(iY);
    pcDstLine = (unsigned char *)out_pImage->GetLinePointer(iY);

    for (int iX = 1; iX < in_pImage->GetWidth() - 1; iX ++)
    {
      // blue
      pcDstLine[iX * 3] = (unsigned char)((pcSrcLine[iX * 3 - 3] + pcSrcLine[iX * 3] + pcSrcLine[iX * 3 + 3]) / 3.0);
      // green
      pcDstLine[iX * 3 + 1] = (unsigned char)((pcSrcLine[iX * 3 - 3 + 1] + pcSrcLine[iX * 3 + 1] + pcSrcLine[iX * 3 + 3 + 1]) / 3.0);
      // red
      pcDstLine[iX * 3 + 2] = (unsigned char)((pcSrcLine[iX * 3 - 3 + 2] + pcSrcLine[iX * 3 + 2] + pcSrcLine[iX * 3 + 3 + 2]) / 3.0);
    }
  }
}



//---------------------------------------------------------------------------
//    

void Colorize(DSimpleBitmap *out_pImage)
{
  //    
  for (int iY = 0; iY < out_pImage->GetHeight(); iY ++)
  {
    unsigned char *pcDstLine;

    //     -    
    pcDstLine = (unsigned char *)out_pImage->GetLinePointer(iY);

    for (int iX = 0; iX < out_pImage->GetWidth() - 0; iX ++)
    {
      ///      
      // blue
      pcDstLine[iX * 3] = iX % 256;
      // green
      pcDstLine[iX * 3 + 1] = 255 - iX % 256;
      // red
      pcDstLine[iX * 3 + 2] = abs(iX - out_pImage->GetWidth() / 2) % 256;
    }
  }
}